var system = require("../../../system");
const http = require("http");
const querystring = require('querystring');
var settings = require("../../../../config/settings");
const CtlBase = require("../../ctl.base");
const moment = require('moment');
class CacheInfoCtl extends CtlBase {
  constructor() {
    super("bizchance", CtlBase.getServiceName(CacheInfoCtl));
  }

  /*根据交付单id获取缓存详情*/
  async findInfoByDeliverId(pobj,qobj,req){
    if (pobj.deliverNumber && pobj.deliverNumber != 'undefined')
    {
      try{
        var rs = await this.service.findInfoByDeliverId(pobj);
        var rarr = {};
        if (rs){
          rarr.deliverNumber = rs.deliver_id;
          rarr.cacheInfo = rs.cache_info;
        }
        return system.getResult(rarr);
      }
      catch(error){
        return system.getResultError(error);
      }
    }
    else{
      return system.getResultError("参数错误！");
    }
  }

  /*根据交付单id更新缓存信息*/
  async updateInfoByDeliverId(pobj,qobj,req){
    if (pobj.deliverNumber && pobj.deliverNumber != 'undefined' && pobj.cacheInfo && pobj.cacheInfo != 'undefined'){
      try{
        var res = await this.service.updateInfoByDeliverId(pobj);
        return system.getResult("更新成功！");
      }
      catch (error){
        return system.getResultError(error);
      }
    }
    else{
      return system.getResultError("参数错误!");
    }
  }

  /*插入或更新缓存信息 */
  async createInfo(pobj,qobj,req){
    if (pobj.deliverNumber && pobj.deliverNumber != 'undefined' && pobj.cacheInfo && pobj.cacheInfo != 'undefined'){
      try{
        var rs = await this.service.findInfoByDeliverId(pobj);
        if (rs){
          await this.service.updateInfoByDeliverId(pobj);
        }
        else{
          await this.service.insertInfo(pobj);
        }
        
        return system.getResult("操作成功！");
      }
      catch (error){
        return system.getResultError(error);
      }
    }
    else{
      return system.getResultError("参数错误!");
    }
  }

  timeFormat(date) {
    let localTime = moment.utc(date).toDate();
    localTime = moment(localTime).format("YYYY-MM-DD");
    return localTime;
  }
}
module.exports = CacheInfoCtl;

// var task = new CacheInfoCtl();
// var obj={"demand_code":"30030302992","business_status":"isFinished"};
// task.updateStatusByDemandCode(obj,{},{}).then(d=>{
//   console.log(d);
//   //console.log(d[0].analyse);

// })
