const system = require("../../../system");
const Dao = require("../../dao.base");
class MaterialDao extends Dao {
  constructor() {
    super(Dao.getModelName(MaterialDao));
  }

  /*根据交付单编号获取注册材料信息详情*/
  async findInfoByDeliverNumber(qobj){
    var qcwhere = {"delivery_code":qobj.deliverNumber};
    return await this.findOne(qcwhere);
  }  

  /*根据交付单编号更新交材料详情*/
  async updateInfoByDeliverNumber(qobj,t){
    var whereobj = {"delivery_code":qobj.deliverNumber};
    var setobj = {};
    if (qobj.companyInfo && qobj.companyInfo != 'undefined'){
      setobj.company_info = qobj.companyInfo;
    }
    if (qobj.registeredInfo && qobj.registeredInfo != 'undefined'){
      setobj.registered_info = qobj.registeredInfo;
    }
    if (qobj.contributionInfo && qobj.contributionInfo != 'undefined'){
      setobj.contribution_info = qobj.contributionInfo;
    }
    if (qobj.positionInfo && qobj.positionInfo != 'undefined'){
      setobj.position_info = qobj.positionInfo;
    }
    if (qobj.managerInfo && qobj.managerInfo != 'undefined'){
      setobj.position_info =  qobj.managerInfo;
    }
    if (qobj.regInfo && qobj.regInfo != 'undefined'){
      setobj.file_info = qobj.regInfo;
    }
    if (qobj.expressInfo && qobj.expressInfo != 'undefined'){
      setobj.express_info = qobj.expressInfo;
    }
    return await this.updateByWhere(setobj,whereobj,t);
  }


  /*插入注册材料信息*/
  async insertInfo(qobj,t){//公司注册，云上园区注册时的信息
    var obj = {
        "delivery_code":qobj.deliverNumber
    };
    if (qobj.deliverId && qobj.deliverId != 'undefined'){
        obj["delivery_id"] = qobj.deliverId;
    }
    if (qobj.companyInfo && qobj.companyInfo != 'undefined'){
      obj.company_info = qobj.companyInfo;
    }
    if (pobj.registeredInfo && pobj.registeredInfo != 'undefined'){
      obj.registered_info = pobj.registeredInfo;
    }
    if (pobj.positionInfo && pobj.positionInfo != 'undefined'){
      obj.position_info = pobj.positionInfo;
    }
    if (pobj.regInfo && pobj.regInfo != 'undefined'){
      obj.file_info = pobj.regInfo;
    }
    if (pobj.expressInfo && pobj.expressInfo != 'undefined'){
      obj.express_info = pobj.expressInfo;
    }
    return await this.create(obj,t);
  }


}
module.exports = MaterialDao;
