const system = require("../../../system");
const ServiceBase = require("../../sve.base");
const settings = require("../../../../config/settings");
const appconfig = system.getSysConfig();
class DeliverybillService extends ServiceBase {
    constructor() {
        super("bizchance", ServiceBase.getDaoName(DeliverybillService));
    }
    async statBizDelivery(companyId,opath,username,userid){
                //如果当前登录人是平台,返回所有商机
                let waittoHandledCount=0//received
                let handlingCount=0
                let finishedCount=0//success
                let closedCount=0//closed
                let toSettle=0
                let toSettleAmount=0
                let settling=0
                let settlingAmount=0
                let settled=0
                let settledAmount=0
                if(companyId==1){
                      waittoHandledCount=await this.dao.findCount({where:{delivery_status:'received'}})
                      handlingCount=await this.dao.findCount({where:{delivery_status:{[this.db.Op.notIn]:['received','success','closed']}}})
                      finishedCount=await this.dao.findCount({where:{delivery_status:'success'}})
                      closedCount=await this.dao.findCount({where:{delivery_status:'closed'}})
                      toSettle=await this.dao.findCount({where:{settle_status:'waittosettle'}})
                      toSettleAmount=await this.dao.findSum('cost_price',{where:{settle_status:'waittosettle'}})
                      settling=await this.dao.findCount({where:{settle_status:'settling'}})
                      settlingAmount=await this.dao.findSum('cost_price',{where:{settle_status:'settling'}})
                      settled=await this.dao.findCount({where:{settle_status:'settled'}})
                      settledAmount=await this.dao.findSum('cost_price',{where:{settle_status:'settled'}})
                }else{
                    let opathstr=''
                    if(opath){
                      opathstr=opath
                      waittoHandledCount=await this.dao.findCount({where:{delivery_status:'received',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      handlingCount=await this.dao.findCount({where:{delivery_status:{[this.db.Op.notIn]:['received','success','closed']},salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      finishedCount=await this.dao.findCount({where:{delivery_status:'success',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      closedCount=await this.dao.findCount({where:{delivery_status:'closed',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      toSettle=await this.dao.findCount({where:{settle_status:'waittosettle',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      toSettleAmount=await this.dao.findSum('cost_price',{where:{settle_status:'waittosettle',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      settling=await this.dao.findCount({where:{settle_status:'settling',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      settlingAmount=await this.dao.findSum('cost_price',{where:{settle_status:'settling',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      settled=await this.dao.findCount({where:{settle_status:'settled',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                      settledAmount=await this.dao.findSum('cost_price',{where:{settle_status:'settled',salesman_opcode:{ [this.db.Op.like]:`%${opathstr}%`},'facilitator_id':companyId}})
                    }else{
                        waittoHandledCount=await this.dao.findCount({where:{delivery_status:'received','facilitator_id':companyId}})
                        handlingCount=await this.dao.findCount({where:{delivery_status:{[this.db.Op.notIn]:['received','success','closed']},'facilitator_id':companyId}})
                        finishedCount=await this.dao.findCount({where:{delivery_status:'success','facilitator_id':companyId}})
                        closedCount=await this.dao.findCount({where:{delivery_status:'closed','facilitator_id':companyId}})
                        toSettle=await this.dao.findCount({where:{settle_status:'waittosettle','facilitator_id':companyId}})
                        toSettleAmount=await this.dao.findSum('cost_price',{where:{settle_status:'waittosettle','facilitator_id':companyId}})
                        settling=await this.dao.findCount({where:{settle_status:'settling','facilitator_id':companyId}})
                        settlingAmount=await this.dao.findSum('cost_price',{where:{settle_status:'settling','facilitator_id':companyId}})
                        settled=await this.dao.findCount({where:{settle_status:'settled','facilitator_id':companyId}})
                        settledAmount=await this.dao.findSum('cost_price',{where:{settle_status:'settled','facilitator_id':companyId}})
                    }
                    
                }
                //成单率
                let allHandled=finishedCount+closedCount
                //如果当前登录人不是平台,那么需要按照opath查询
                return {
                    waittoHandledCount:waittoHandledCount,
                    handlingCount:handlingCount,
                    finishedCount:finishedCount,
                    closedCount:closedCount,
                    allHandled:allHandled,
                    toSettle:toSettle,
                    toSettleAmount:toSettleAmount?toSettleAmount:0,
                    settling:settling,
                    settlingAmount:settlingAmount?settlingAmount:0,
                    settled:settled,
                    settledAmount:settledAmount?settledAmount:0
                }

    }
    async settleApply(ids,uid,uname){
        var self=this
         return this.db.transaction(async function (t){
             //先按照ids查询出交付单的合计服务成本
              let settleAmount=await self.dao.findSum("cost_price",{where:{id:{[self.db.Op.In]:ids}},transaction:t})
              settleAmount=isNaN(settleAmount)?0:settleAmount
              let settlecode=await self. getBusUid("JSD")
              let settleObj={
                  code:settlecode,
                  settle_amount:settleAmount,
                  creator_id:uid,
                  creator:uname
              }
              //生成结算单，结算单状态为待审核
              let newentity=await self.db.models.settlebill.create(settleObj,{transaction:t})
             //然后按照ids更新交付单的状态为结算中，更新结算单的id到交付单表
             for(let idstr of ids){
                let up = await self.dao.updateByWhere({settle_status:'settling',
                settlebill_id:newentity.id }, { id: idstr }, t);
             }
              return newentity
         }); 
    }
    async findAndCountAll(obj) {
        var self = this;
        const apps = await this.dao.findAndCountAll(obj);
        return apps;
    }

    async findInfoByDeliverCode(qobj){//*根据交付单编号获取交付单详情*/
        return await this.dao.findInfoByDeliverCode(qobj);
    }

    async updateStatusByDeliverCode(qobj){//* 根据交付单编号更新交付单状态 */
        var self=this;
        return self.db.transaction(async function (t) {
            return await self.dao.updateStatusByDeliverCode(qobj,t);
        });
    }
    
    async updateInfoByDeliverCode(qobj){//*更新交付单信息 */
        console.log("--------------------------------------------------------------------------------------------------------------------------------------");
        var self=this;
        return self.db.transaction(async function (t) {
            return await self.dao.updateInfoByDeliverCode(qobj,t);
        });
    }

    async insertInfo(qobj){//*插入交付单信息*/从队列取数据的时候用
        var self=this;
        return self.db.transaction(async function (t) {
            return await self.dao.insertInfo(qobj,t);
        }); 
    }

}
module.exports = DeliverybillService;